// LPEReLocal.cpp: implementation of the LPEReLocal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "protect.h"
#include "LPEReLocal.h"
#include "LPESection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LPEReLocal::LPEReLocal()
{

}

LPEReLocal::~LPEReLocal()
{

}

void LPEReLocal::operator =(LPEFile& lPeFile)
{
    SetInfo(lPeFile.GetInfo());
}

//õضλĽṹַ

/*ṹ
IMAGE_DIRECTORY_ENTRY_BASERELOC
struct _IMAGE_DATA_DIRECTORY
{
	0x00 DWORD VirtualAddress;
	0x04 DWORD Size
}
*/

/*ṹGetDirectoryEntryToDataѾõṹеVirtualAddressҷصľǽṹеVirtualAddress
typedef struct _IMAGE_BASE_RELOCATION {
DWORD   VirtualAddress;
DWORD   SizeOfBlock;
//  WORD    TypeOffset[1];
} IMAGE_BASE_RELOCATION;
*/

//ص_IMAGE_BASE_RELOCATIONṹĵַ
PIMAGE_BASE_RELOCATION LPEReLocal::GetFirstReLocaltion()
{
	PIMAGE_BASE_RELOCATION pRelocalDesc =NULL;
    pRelocalDesc= (PIMAGE_BASE_RELOCATION)GetDirectoryEntryToData(IMAGE_DIRECTORY_ENTRY_BASERELOC);
	if (pRelocalDesc == NULL)
	{
		return NULL;
	}
	return pRelocalDesc;
}


//õضλĸ
int LPEReLocal::GetReLocalCount()
{
	int i=0;
	DWORD dwOffset;   
	//õ׸ضλĵַ
	PIMAGE_DATA_DIRECTORY pDataDir = GetDataDirectory(IMAGE_DIRECTORY_ENTRY_BASERELOC);
	dwOffset = pDataDir->VirtualAddress; 
	PIMAGE_BASE_RELOCATION pTempRelocal = GetFirstReLocaltion();
	//жַǷΪ0õضλĸ
	while(pTempRelocal->VirtualAddress)
	{
		++i;
		dwOffset = dwOffset +(pTempRelocal->SizeOfBlock);
		pTempRelocal = (PIMAGE_BASE_RELOCATION)RvaToPtr(dwOffset);
	}
	return i;
}


//nIndexҪõڼضλrdwOffsetضλǰĵַrʾֵ
//DWORD *rdwOffsetָݽȥ&...
PIMAGE_BASE_RELOCATION LPEReLocal::GetReLocal(int nIndex, DWORD *rdwOffset)
{
	PIMAGE_BASE_RELOCATION pRelocal = NULL;
	DWORD dwOffset = 0;
	int nCount = GetReLocalCount();
	PIMAGE_DATA_DIRECTORY pDataDir = GetDataDirectory(IMAGE_DIRECTORY_ENTRY_BASERELOC);
	
	//dwOffsetõṹеVirtualAddress
	/*
	IMAGE_DIRECTORY_ENTRY_BASERELOC
	struct _IMAGE_DATA_DIRECTORY {
		 DWORD VirtualAddress;
         DWORD Size;
	}
	*/
	dwOffset = pDataDir->VirtualAddress;

	//õ׸ضλĵַ
	PIMAGE_BASE_RELOCATION pTempReLocal = GetFirstReLocaltion();

	int j =0;
	if (nIndex < nCount)
	{
		while(pTempReLocal->VirtualAddress)
		{
			if (nIndex == (j++))
			{
				pRelocal = pTempReLocal;
				//Ҫصĵַ

				*rdwOffset = dwOffset;
				break;
				//ûҪʱif
			}
			dwOffset = dwOffset +(pTempReLocal->SizeOfBlock);
			//dwOffsetpTempReLocal->SizeOfBlockҲǴʱضλĸ 
			//ָ¸ضλĵַ
			

			//dwOffsetVirtualAddressתļƫƣַ
			pTempReLocal = (PIMAGE_BASE_RELOCATION)RvaToPtr(dwOffset);
			//pTempReLocalʼĳضλ׵ַ
		}
	}
	return pRelocal;
	//صĳضλ׵ַ

}


//õĳضλҪضλٸ
int LPEReLocal::GetTypeOffsetCount(int nIndex)
{
	int i=0;
	DWORD dwOffset;
	PIMAGE_BASE_RELOCATION pReLocal = GetReLocal(nIndex,&dwOffset);
	if (pReLocal !=NULL)
	{
		i =( pReLocal->SizeOfBlock - sizeof(IMAGE_BASE_RELOCATION) )/sizeof(WORD);
		//IMAGE_BASE_RELOCATIONṹDWORD   VirtualAddress;DWORD   SizeOfBlock;
		//sizeof(IMAGE_BASE_RELOCATION)/sizeof(WORD)4

		//оⰡ,Ŷ԰ i = (pReLocal->SizeOfBlock - sizeof(IMAGE_BASE_RELOCATION) )/sizeof(WORD);

	}
	return i;

}

//WORD
//һضλһ
WORD LPEReLocal::GetTypeOffset(int nRelocalIndex, int nOffsetIndex)
{
	DWORD dwRva;
	PIMAGE_BASE_RELOCATION pReLocal = GetReLocal(nRelocalIndex,&dwRva);
	
	LPESection lPeSection;
    lPeSection.SetInfo(GetInfo());
	//lPeSectionָPEļ
	DWORD dwFileOffset = lPeSection.RvaToOffset(dwRva);
	//װΪļַ
	WORD wTypeOffset = 0;
	if (pReLocal !=NULL)
	{
		//дĵַ&wTypeOffsetи&ʾַ
		memcpy(&wTypeOffset,GetImage()+dwFileOffset+sizeof(IMAGE_BASE_RELOCATION)+
		   sizeof(WORD)*nOffsetIndex,sizeof(WORD));
		//GetImage()+dwFileOffsetĿǰĳضλĵַ
		//sizeof(IMAGE_BASE_RELOCATION),8ֽ
		//sizeof(WORD)*nOffsetIndex,sizeof(WORD)nOffsetIndexݣ*WORD
		//sizeof(WORD)С
	}
	return wTypeOffset;
	
}

//õضλݵ
WORD LPEReLocal::GetReLocationType(int nRelocalIndex, int nTypeOffsetIndex)
{
   //4λ3ҪضλWORD16λ
   WORD wTypeOffset=GetTypeOffset(nRelocalIndex,nTypeOffsetIndex);
   wTypeOffset&=0xF000;
   wTypeOffset = wTypeOffset>>12;
   return wTypeOffset;
}




DWORD LPEReLocal::GetReLocaltionRVA(int nRelocalIndex, int nTypeOffsetIndex)
{
	DWORD dwOffset;
	PIMAGE_BASE_RELOCATION pReLocal = GetReLocal(nRelocalIndex,&dwOffset);
    WORD wTypeOffset = GetTypeOffset(nRelocalIndex,nTypeOffsetIndex);
	
	wTypeOffset &= 0x0FFF;
	//õضλݵRVAȥ˸4λжݣʹ֮Ϊ0
	return pReLocal->VirtualAddress + wTypeOffset;


}


//ԼݶεRVA͵ǰIMAGEBASE
BOOL LPEReLocal::RelocationMySelf(DWORD dwNewSecAddress, DWORD dwImageBase)
{
	//õٸضλ
	int iRelocalCount = GetReLocalCount();
	for (int i=0;i<iRelocalCount;i++)
	{
		//ضλжٸضλ
		int iTypeOffset = GetTypeOffsetCount(i);
		for (int j=0;j<iTypeOffset;j++)
		{
			if (GetReLocationType(i,j)==3)
			{
				//           ½ڵַ       PEַӿEXE          
				RelocaltionVA(dwNewSecAddress,dwImageBase,*(DWORD*)RvaToPtr(GetReLocaltionRVA(i,j)));
				//*(DWORD*)RvaToPtr(GetReLocaltionRVA(i,j)ضλ
			}
		}
	}
	return TRUE;

}

//dwOldVAǸָ룬ı,dwOldVA˾ʽĵַ
BOOL LPEReLocal::RelocaltionVA(DWORD dwNewAddress, DWORD dwNewImageBase, DWORD &dwOldVA)
{
	PIMAGE_OPTIONAL_HEADER pOptHeader=GetNtOptionalHeader();
	dwOldVA-=pOptHeader->ImageBase;
	dwOldVA-=0x1000;
	dwOldVA+=dwNewAddress;
	dwOldVA+=dwNewImageBase;
	return true;
}
