// LPEFile.h: interface for the LPEFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LPEFILE_H__869EE97E_7A5F_4BA7_8828_7FEE11C91D3C__INCLUDED_)
#define AFX_LPEFILE_H__869EE97E_7A5F_4BA7_8828_7FEE11C91D3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct _MAP_FILE_STRUCT
{
	HANDLE hFile;    //򿪵ļ
	HANDLE hMapping;  //ļӳ䵽ڴľ
	LPVOID ImageBase;  //ļ
	DWORD  dwFileSize;  //ļĴС
}  MAP_FILE_STRUCT,*PMAP_FILE_STRUCT;

enum{
	    LFILE_FROM_NOMAL=0,       //ļʱĴʽ
		LFILE_FROM_FILE,
		LFILE_FROM_MEMORY
};

class LPEFile  
{
public:
	BOOL LoadPEFile(BYTE *lpBuffer, DWORD dwSize);
	LPVOID RvaToPtr(DWORD dwRVA);
	LPVOID GetDirectoryEntryToData(USHORT DirectoryEntry);
	PIMAGE_SECTION_HEADER GetSection(int nIndex);
	BOOL IsPEFile();
	PIMAGE_SECTION_HEADER GetFirstSectionHeader();
	int GetSectionCount();
	PIMAGE_DATA_DIRECTORY GetDataDirectory(int nIndex);
	PIMAGE_DATA_DIRECTORY GetDataDirectory();
	PIMAGE_OPTIONAL_HEADER GetNtOptionalHeader();
	PIMAGE_FILE_HEADER GetNtFileHeader();
	PIMAGE_NT_HEADERS GetNtHeader();
	PIMAGE_DOS_HEADER GetDosHeader();
	DWORD GetImageSize();
	BYTE* GetImage();
	bool Free();
	BOOL LoadPEFile(char* lpFilename);
	BOOL SetInfo(MAP_FILE_STRUCT *pMapFileMsg);
	MAP_FILE_STRUCT* GetInfo();
	void operator=(LPEFile& lPeFile);
	LPEFile();
	virtual ~LPEFile();

private:
	//ڱʶļĴ״̬//ڱʶļĴ״̬
    BYTE bLoadStact;    
    //ڴ洢򿪵ļļݣļС
protected:
	MAP_FILE_STRUCT *pstMapFile;
};

#endif // !defined(AFX_LPEFILE_H__869EE97E_7A5F_4BA7_8828_7FEE11C91D3C__INCLUDED_)
