// LPEImport.cpp: implementation of the LPEImport class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "LPEImport.h"
#include "LPESection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LPEImport::LPEImport()
{

}

LPEImport::~LPEImport()
{

}

void LPEImport::operator =(LPEFile& lPeFile)
{
    SetInfo(lPeFile.GetInfo());
}
//õ׸
PIMAGE_IMPORT_DESCRIPTOR LPEImport::GetFirstImportDesc()
{
    PIMAGE_IMPORT_DESCRIPTOR pImportDesc;
	pImportDesc=(PIMAGE_IMPORT_DESCRIPTOR)GetDirectoryEntryToData(IMAGE_DIRECTORY_ENTRY_IMPORT);
	if(!pImportDesc)
		return NULL;	 
	return  pImportDesc;
}
//õжٸdll
int LPEImport::GetImportDesCount()
{
	int i=0;
	PIMAGE_IMPORT_DESCRIPTOR pTempImport=GetFirstImportDesc();
	while (pTempImport->FirstThunk)
	{
		++i;
		++pTempImport;
	}
	return i;
}

// õĳdll
PIMAGE_IMPORT_DESCRIPTOR LPEImport::GetImportDesc(int index)
{
    int i=GetImportDesCount();
	if (index>=i)
	{
		return NULL;
	}
	PIMAGE_IMPORT_DESCRIPTOR pTempImport=GetFirstImportDesc();
	return &pTempImport[index];
}

//õĳAPI 
PIMAGE_IMPORT_BY_NAME LPEImport::GetImportFucByName(DWORD RavThunk)
{
	PIMAGE_NT_HEADERS     pNtH=NULL;
	PIMAGE_IMPORT_BY_NAME pApiName=NULL;
	
	pApiName=(PIMAGE_IMPORT_BY_NAME)RvaToPtr(RavThunk);

	return pApiName;
}

DWORD LPEImport::GetImportThunk(PIMAGE_IMPORT_DESCRIPTOR pImportDesc)
{
	return pImportDesc->OriginalFirstThunk?pImportDesc->OriginalFirstThunk:pImportDesc->FirstThunk;
}


//½ڵRVA
BOOL LPEImport::ReLocalImport(DWORD dwRVA)
{
	int iCount = GetImportDesCount();
	//õĸDLLĸ
	LPESection lPeSection;
	lPeSection.SetInfo(GetInfo());

	for (int i=0;i<iCount;i++)
	{
		PIMAGE_IMPORT_DESCRIPTOR pImport=GetImportDesc(i);
		DWORD dwOrThunk = pImport->OriginalFirstThunk;
		DWORD dwIatThunk = pImport->FirstThunk;
		
		//̣ھпֱӸĻرӿPE
		pImport->OriginalFirstThunk += (dwRVA-0x2000);
		pImport->Name += (dwRVA-0x2000);
		pImport->FirstThunk += (dwRVA-0x2000);

		while(*(DWORD *)RvaToPtr(dwOrThunk) != 0)
		{
			//е
			*(DWORD *)RvaToPtr(dwOrThunk) += (dwRVA-0x2000);
			*(DWORD*)RvaToPtr(dwIatThunk)+=(dwRVA-0x2000);
		
			//dwOrThunkԭ
			dwOrThunk+=sizeof(DWORD);
		    dwIatThunk+=sizeof(DWORD);
		}

	}
	return TRUE;

}
