// LPEReLocal.h: interface for the LPEReLocal class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LPERELOCAL_H__1F52431D_4F00_4195_AA17_DAD3B7E17507__INCLUDED_)
#define AFX_LPERELOCAL_H__1F52431D_4F00_4195_AA17_DAD3B7E17507__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LPEFile.h"

class LPEReLocal : public LPEFile  
{
public:
	BOOL RelocaltionVA(DWORD dwNewAddress, DWORD dwNewImageBase, DWORD &dwOldVA);
	BOOL RelocationMySelf(DWORD dwNewSecAddress, DWORD dwImageBase);
	DWORD GetReLocaltionRVA(int nRelocalIndex, int nTypeOffsetIndex);
	WORD GetTypeOffset(int nRelocalIndex, int nOffsetIndex);
	WORD GetReLocationType(int nRelocalIndex, int nTypeOffsetIndex);
	int GetTypeOffsetCount(int nIndex);
	PIMAGE_BASE_RELOCATION GetReLocal(int nIndex, DWORD *rdwOffset);
	int GetReLocalCount();
	PIMAGE_BASE_RELOCATION GetFirstReLocaltion();
	LPEReLocal();
	virtual ~LPEReLocal();
	void operator=(LPEFile& lPeFile);

};

#endif // !defined(AFX_LPERELOCAL_H__1F52431D_4F00_4195_AA17_DAD3B7E17507__INCLUDED_)
