// protectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "protect.h"
#include "protectDlg.h"
#include "LPEFile.h"
#include "LPESection.h"
#include "LPEReLocal.h"
#include "LPEImport.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProtectDlg dialog

CProtectDlg::CProtectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProtectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProtectDlg)
	m_strKey = _T("");
	m_strFileName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProtectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProtectDlg)
	DDX_Text(pDX, IDC_EDIT_KEY, m_strKey);
	DDX_Text(pDX, IDC_EDIT_PATH, m_strFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProtectDlg, CDialog)
	//{{AFX_MSG_MAP(CProtectDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProtectDlg message handlers

BOOL CProtectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProtectDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProtectDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProtectDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CProtectDlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE,"exe","",OFN_OVERWRITEPROMPT,"ļ(*.exe)|*.exe||");
    if (dlg.DoModal()!=IDOK)
    {
		return;
    }
	m_strFileName = dlg.GetPathName();
	UpdateData(FALSE);
}

void CProtectDlg::OnOK() 
{
	
	// TODO: Add extra validation here
	UpdateData(TRUE);
	LPEFile lPeFile,lPeStup;
	LPESection lPeSection,lPeStupSection;
	LPEReLocal lPeReloc,lStupReloc;
	LPEImport lPeStupImport;

	DWORD dwSectionSize = 1024;

	if (!LoadPE(&lPeFile,&lPeStup))
    {
		MessageBox("ļ");
    }

//	lPeFile.LoadPEFile(m_strFileName.GetBuffer(0));

	lPeStupSection = lPeStup;

	//                                           Ǹڵݣ С          
	LPBYTE lpStupBuffer = lPeStupSection.GetSectionData(0,&dwSectionSize);
	
	//
 	lPeSection = lPeFile;
	lPeSection.AddSection(".lang",dwSectionSize,IMAGE_SCN_MEM_READ|IMAGE_SCN_MEM_WRITE|IMAGE_SCN_MEM_EXECUTE);

	//õһͷ
	PIMAGE_SECTION_HEADER pStupSection = lPeFile.GetSection(lPeFile.GetSectionCount()-1);
    //ضλһҪдǰ
	lStupReloc = lPeStup;
	lStupReloc.RelocationMySelf(pStupSection->VirtualAddress,lPeStup.GetNtOptionalHeader()->ImageBase);

	//д룬
	lPeSection.WriteSectionData(lPeSection.GetSectionCount()-1,0,lpStupBuffer,&dwSectionSize);
	//lPeSection.GetSectionCount()-1 -1¼ӽ
	//0ҪдڵƫλΪ0 ǽڵʼ
	//lpStupBufferҪдݵĵַ
    //С

	//ıԴڵ
	lPeFile.GetNtOptionalHeader()->AddressOfEntryPoint = (DWORD) (pStupSection->VirtualAddress + lPeStup.GetNtOptionalHeader() - 0x1000);

//	lPeFile.GetNtOptionalHeader()->AddressOfEntryPoint=pStupSection->VirtualAddress+lPeStup.GetNtOptionalHeader()->AddressOfEntryPoint-0x1000;

	
	lPeSection.AddSection(".rlang",dwSectionSize,IMAGE_SCN_MEM_READ|IMAGE_SCN_MEM_WRITE|IMAGE_SCN_CNT_INITIALIZED_DATA);

	//õһڵĽͷ
	PIMAGE_SECTION_HEADER pImportSection = lPeFile.GetSection(lPeFile.GetSectionCount()-1);

	lPeStupImport=lPeStup;
	lPeStupImport.ReLocalImport(pImportSection->VirtualAddress);


	//DLLĵд
	lpStupBuffer = lPeStupSection.GetSectionData(1,&dwSectionSize);
	//õ¼ӵڶڵ
	lPeSection.WriteSectionData(lPeSection.GetSectionCount()-1,0,lpStupBuffer,&dwSectionSize);


	//ı䵼λPIMAGE_DATA_DIRECTORYṹе
	PIMAGE_DATA_DIRECTORY pImageDataDir = (PIMAGE_DATA_DIRECTORY)lPeStup.GetDataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT);
    //lPeStup
	DWORD dwStupImportRVA = pImageDataDir->VirtualAddress;
	
	dwStupImportRVA -= 0x2000; //2000ǰᡣtextδС0x1000
	dwStupImportRVA += pImportSection->VirtualAddress;
	//pImportSection->VirtualAddress½ڵĽͷַ

	pImageDataDir = (PIMAGE_DATA_DIRECTORY)lPeFile.GetDataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT);
    //lPeFile

	pImageDataDir->VirtualAddress = dwStupImportRVA;
	//õµĵ


	
	
	
	
//	lPeReloc = lPeFile;
// 	DWORD dwAddress;//ܷصĵַ
// 	PIMAGE_BASE_RELOCATION pTempRec;
// 	char strBuffer[MAX_PATH];//ʽضλ
// 	int nRecCount=lPeReloc.GetReLocalCount();//
//	int nRecIndex=1;

// 	for (int i =0;i<nRecCount;i++)
// 	{
//          ZeroMemory(strBuffer,MAX_PATH);
//          pTempRec=lPeReloc.GetReLocal(i,&dwAddress);
// 		 sprintf(strBuffer,"%d,RVA=%.8X,SIZE=%.8X",i+1,pTempRec->VirtualAddress,pTempRec->SizeOfBlock);
// 		 OutputDebugString(strBuffer);
// 	}

// 	int nTypeOffsetCount = lPeReloc.GetTypeOffsetCount(nRecIndex);
// 
// 	pTempRec = lPeReloc.GetReLocal(nRecIndex,&dwAddress);
// 
// 	//ضλе
// 	for (int i=0;i<nTypeOffsetCount;i++)
// 	{
// 		ZeroMemory(strBuffer,MAX_PATH);
// 		sprintf(strBuffer,"%d,RVA=%.8X,TYPE=(%d)",i+1,lPeReloc.GetReLocaltionRVA(nRecIndex,i),lPeReloc.GetReLocationType(nRecIndex,i));
// 		//                                                     nRecIndexڼضλiڼ                  ͬ
// 	    OutputDebugString(strBuffer);
// 	}




	

	AfxMessageBox("OK");
	//CDialog::OnOK();




}


//ṩ2Ҫָ룬һҪӿexe,һDLL
BOOL CProtectDlg::LoadPE(LPEFile *lPeFile, LPEFile *lPEStup)
{
	//ѾԴDllڴ
    HGLOBAL hRes;
	HRSRC   hResInfo;
	DWORD   dwFileSize;
	BYTE*   lpDataBuffer;
	
	hResInfo=FindResource(NULL,MAKEINTRESOURCE(IDR_STUP),"STUP");
	if (hResInfo==NULL)
	{
		return FALSE;
	}
	
	hRes=LoadResource(NULL,hResInfo);
	if (hRes==NULL)
	{
		return FALSE;
	}

	dwFileSize = SizeofResource(NULL,hResInfo);
	lpDataBuffer = (BYTE*)LocalAlloc(LPTR,dwFileSize);
	ZeroMemory(lpDataBuffer,dwFileSize);
	memcpy(lpDataBuffer,hResInfo,dwFileSize);
	//lpDataBufferDLLµַ
	FreeResource(hRes);

	lPEStup->LoadPEFile(lpDataBuffer,dwFileSize);

	lPeFile->LoadPEFile(m_strFileName.GetBuffer(0));

	return TRUE;

}
